<?php
namespace Fiscal\Repositories;

/**
 *
 */
class Contapagar extends \Doctrine\ORM\EntityRepository
{
    public function saveContaPagar($params,$dtEmissao){
        $sql = "INSERT INTO CONTAPAGAR
                            (CDFILIAL, NRLANCTONF, NRSEQVENPAG, NRPARCELAPAG, QTDIASVENPAG, DTORIGVENPAG,
                            VRORIGPAG, DSCONTAPAG, DTATUAVENPAG, VRATUAPAG, IDSTATPAG, CDTPCTPAGAR,CDCLASSFINA)
                     VALUES (?,?,?,?,nvl(?,1),TO_DATE(?,'DD/MM/YYYY'),?,?,TO_DATE(?,'DD/MM/YYYY'),?,?,?,?)";
        $connection = $this->getEntityManager()->getConnection();
        return $connection->executeUpdate($sql,$params);
    }

    /**
     * Retorna o tipo de conta a pagar de determinada nota fiscal.
     *
     * @param $cdfilial
     * @param $nrlanctonf
     * @param $nrorg
     *
     * @return string
     *
     * @throws \Exception
     */
    public function getTipoContaPagar($cdfilial, $nrlanctonf, $nrorg)
    {
        $sql = "SELECT MAX(CDTPCTPAGAR) AS CDTPCTPAGAR
                FROM CONTAPAGAR
                WHERE CDFILIAL   = '$cdfilial'
                  AND NRLANCTONF = '$nrlanctonf'
                  AND NRORG      = $nrorg";

        try {
            return $this->getEntityManager()->getConnection()->fetchColumn($sql);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getMaxNRSEQVENPAG($filial, $lancamento){
    	$sql = <<<SQL
        SELECT NVL(MAX(NRSEQVENPAG),'00') AS NRSEQVENPAG
          FROM CONTAPAGAR
         WHERE CDFILIAL   = :P_CDFILIAL
           AND NRLANCTONF = :P_NRLANCTONF
SQL;
    
    	$params = array(
    			"P_CDFILIAL" => $filial,
    			"P_NRLANCTONF" => $lancamento,
    	);
    
    	try{
    		return self::getEntityManager()->getConnection()->fetchColumn($sql, $params);
    	} catch(\Exception $e) {
    		throw $e;
    	}
    }

}